Ruby: pm_constant_path_or_write_node Struct Reference

Ruby 3.4.6p54 (2025-09-16 revision dbd83256b1cec76c69756ecb8758b9e1079833de)

Data Fields
pm_constant_path_or_write_node Struct Reference

ConstantPathOrWriteNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
struct pm_constant_path_node * | target
| ConstantPathOrWriteNode#target.
pm_location_t | operator_loc
| ConstantPathOrWriteNode#operator_loc.
struct pm_node * | value
| ConstantPathOrWriteNode#value.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

ConstantPathOrWriteNode.

Represents the use of the ||= operator for assignment to a constant path.

    Parent::Child ||= value
    ^^^^^^^^^^^^^^^^^^^^^^^

Type: ::PM_CONSTANT_PATH_OR_WRITE_NODE

Definition at line 3291 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_constant_path_or_write_node::base

The embedded base node.

Definition at line 3293 of file ast.h.

Referenced by pm_dump_json().

## ◆ operator_loc

pm_location_t pm_constant_path_or_write_node::operator_loc

ConstantPathOrWriteNode#operator_loc.

Definition at line 3304 of file ast.h.

Referenced by pm_dump_json().

## ◆ target

struct pm_constant_path_node* pm_constant_path_or_write_node::target

ConstantPathOrWriteNode#target.

Definition at line 3299 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ value

struct pm_node* pm_constant_path_or_write_node::value

ConstantPathOrWriteNode#value.

Definition at line 3309 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h